#include <bits/stdc++.h>
using namespace std;
#define si short int
#define ll long long

//brute-force
int main(void)
{

    int n,m;
    cin>>n>>m;
    int b[m+1];
        for(int j=1;j<=m;j++)
            cin>>b[j];
    int c;
    cin>>c;
    int a[n+1];
    for(int i=1;i<=n;i++)
        a[i]=i;
    for(int i=0;i<=n-m;i++)
    {
        for (int j=1; j<=m; j++)
            a[i+b[j]]=a[i+j];
    }
    int x=0;
    for(int i=1;i<=n;i++)
        x+=pow(c,i)*a[i];
    cout<<x%998244353;
}